//
//  FSGPUImageFilterManager.h
//  MultiViewFilterExample
//
//  Created by Shi Forrest on 12-6-11.
//  Copyright (c) 2012年 Cell Phone. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "GPUImage.h"

typedef enum {
    GPUIMAGE_SKETCH = 0,
    GPUIMAGE_SEPIA,
    GPUIMAGE_TILTSHIFT,
    GPUIMAGE_VIGNETTE,
    GPUIMAGE_EMBOSS,
    GPUIMAGE_SMOOTHTOON,
    GPUIMAGE_BULGE,
    GPUIMAGE_PINCH,
    GPUIMAGE_STRETCH=8,  // ArtCam 
    GPUIMAGE_POSTERIZE,
    GPUIMAGE_SWIRL,
    GPUIMAGE_TOON,
    GPUIMAGE_CONVOLUTION,
    GPUIMAGE_KUWAHARA,
    GPUIMAGE_SATURATION,
    GPUIMAGE_CONTRAST,
    GPUIMAGE_BRIGHTNESS,
    GPUIMAGE_EXPOSURE,
    GPUIMAGE_RGB,
    GPUIMAGE_SHARPEN,
    GPUIMAGE_UNSHARPMASK,
    GPUIMAGE_TRANSFORM,
    GPUIMAGE_TRANSFORM3D,
    GPUIMAGE_CROP,
	GPUIMAGE_MASK,
    GPUIMAGE_GAMMA,
    GPUIMAGE_TONECURVE,
    GPUIMAGE_HAZE,
    GPUIMAGE_COLORINVERT,
    GPUIMAGE_GRAYSCALE,
    GPUIMAGE_HISTOGRAM,
    GPUIMAGE_THRESHOLD,
    GPUIMAGE_ADAPTIVETHRESHOLD,
    GPUIMAGE_PIXELLATE,
    GPUIMAGE_POLARPIXELLATE,
    GPUIMAGE_CROSSHATCH,
    GPUIMAGE_SOBELEDGEDETECTION,
    GPUIMAGE_PREWITTEDGEDETECTION,
    GPUIMAGE_CANNYEDGEDETECTION,
    GPUIMAGE_XYGRADIENT,
    GPUIMAGE_HARRISCORNERDETECTION,
    GPUIMAGE_NOBLECORNERDETECTION,
    GPUIMAGE_SHITOMASIFEATUREDETECTION,
    GPUIMAGE_CGA,
    GPUIMAGE_GAUSSIAN,
    GPUIMAGE_GAUSSIAN_SELECTIVE,
    GPUIMAGE_FASTBLUR,
    GPUIMAGE_BOXBLUR,
    GPUIMAGE_MEDIAN,
    GPUIMAGE_BILATERAL,
    GPUIMAGE_DILATION,
    GPUIMAGE_EROSION,
    GPUIMAGE_OPENING,
    GPUIMAGE_CLOSING,
    GPUIMAGE_PERLINNOISE,
    GPUIMAGE_VORONI,
    GPUIMAGE_MOSAIC,
    GPUIMAGE_DISSOLVE,
    GPUIMAGE_CHROMAKEY,
    GPUIMAGE_MULTIPLY,
    GPUIMAGE_OVERLAY,
    GPUIMAGE_LIGHTEN,
    GPUIMAGE_DARKEN,
    GPUIMAGE_COLORBURN,
    GPUIMAGE_COLORDODGE,
    GPUIMAGE_SCREENBLEND,
    GPUIMAGE_DIFFERENCEBLEND,
	GPUIMAGE_SUBTRACTBLEND,
    GPUIMAGE_EXCLUSIONBLEND,
    GPUIMAGE_HARDLIGHTBLEND,
    GPUIMAGE_SOFTLIGHTBLEND,
    GPUIMAGE_CUSTOM,
    GPUIMAGE_UIELEMENT,
    GPUIMAGE_FILECONFIG,
    GPUIMAGE_FILTERGROUP,
    GPUIMAGE_NUMFILTERS
} GPUImageShowcaseFilterType; 


@interface FSGPUImageFilterManager : NSObject

@property (strong ,nonatomic ) NSString *title;
@property (strong ,nonatomic ) UISlider *filterSettingsSlider;
@property (strong ,nonatomic ) GPUImagePicture *sourcePicture;

+ (FSGPUImageFilterManager*) sharedFSGPUImageFilterManager;

- (GPUImageFilter*) createGPUImageFilter:(GPUImageShowcaseFilterType)filterType;

@end
